{"openapi":"3.0.0","info":{"description":"REST API for HU which covers these senarios,\n- Delivery of ad information as determined by the server\n- Notification of display of ad infomation by HU\n- Notification of vehicle arrival and leave events","version":"1.0.0","title":"A2VP HU API","contact":{}},"servers":[{"description":"SwaggerHub API Auto Mocking","url":"https://virtserver.swaggerhub.com/xe97/a2vp/1.0.0"},{"description":"","url":"https://app.swaggerhub.com/apis/xe97/a2vp/1.0.0"}],"tags":[{"name":"Brand"},{"name":"POI"},{"name":"Advertisement"},{"name":"Vehicle"},{"name":"Debug"},{"name":"Registration"},{"name":"Links"},{"name":"Favorite"},{"name":"Destination"},{"name":"Navigation"}],"security":[{"api_key":[]}],"paths":{"/brands":{"get":{"tags":["Brand"],"summary":"1. 広告ブランド情報の取得(複)","description":"関連付けられた広告ブランド情報を返す\n","responses":{"200":{"description":"results of get brands","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/BrandItem"}},"examples":{"example-1":{"value":[{"brandId":"xxx","iconUrl":"https://firebasestorage.googleapis.com/v0/b/a2vp-dev.appspot.com/o/icons%2FIYwRFJOaG7YUk0XASfQh?alt=media&token=f3e8a80b-a25e-4e58-bf8d-64035571545a","name":"Advertiser Name"}]}}}}},"401":{"description":"Wrong API key"}},"operationId":"get-brands"}},"/brands/{brandId}":{"get":{"tags":["Brand"],"summary":"2. 広告ブランド報取得(単)","description":"brandIdで示される広告ブランド情報を返す\n","parameters":[{"in":"path","name":"brandId","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"results of get brands","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BrandItem"},"examples":{"example-1":{"value":{"brandId":"xxx","iconUrl":"https://firebasestorage.googleapis.com/v0/b/a2vp-dev.appspot.com/o/icons%2FIYwRFJOaG7YUk0XASfQh?alt=media&token=f3e8a80b-a25e-4e58-bf8d-64035571545a","name":"Advertiser Name"}}}}}},"401":{"description":"Wrong API key"},"404":{"description":"No brand with the brandId."}},"operationId":"get-brands-brandId"}},"/POIs":{"get":{"tags":["POI"],"summary":"3. POI情報の取得(複)","description":"距離範囲とbrandIdのいずれか（または両方）で、限定されるPOI情報を返す。\n","parameters":[{"in":"query","name":"lat","description":"latitude","schema":{"type":"number","minimum":-90,"maximum":90}},{"in":"query","name":"lng","description":"longitude","schema":{"type":"number","minimum":-180,"maximum":180}},{"in":"query","name":"radius","description":"radius (meter)","schema":{"type":"number","minimum":0,"exclusiveMinimum":true}},{"in":"query","name":"brandIds","description":"comma separated list of brandId.","schema":{"type":"array","items":{"type":"string"}},"style":"form","explode":false},{"in":"query","name":"adIds","description":"comma separated list of adId. The size of list must be 10 or less.","schema":{"type":"array","items":{"type":"string"}}}],"responses":{"200":{"description":"results of get POIs","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/POIItem"}},"examples":{}}}},"401":{"description":"Wrong API key"}},"operationId":"get-pois"}},"/POIs/{poiId}":{"get":{"tags":["POI"],"summary":"4. POI情報の取得(単)","description":"poiIdで示されるPOI情報を返す\n","parameters":[{"in":"path","name":"poiId","description":"POI id","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"result of get POI","content":{"application/json":{"schema":{"$ref":"#/components/schemas/POIItem"}}}},"404":{"description":"No POI with the poiId."}},"operationId":"get-pois-poiid"}},"/advertisements":{"post":{"tags":["Advertisement"],"summary":"10. 広告情報の取得(複)","description":"リクエストボディの内容（現在地の広告、経路情報に基づく広告、表示履歴に基づく広告）が示す、広告情報を返す。","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AdRequest"}}},"description":"広告の種類（現在値、経路情報、視聴履歴）、および各種類における値（位置情報、経過時間）"},"responses":{"200":{"description":"the ad for the route which determined by the server","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/AdItem"}}}}},"400":{"description":"bad input parameter"},"401":{"description":"Wrong API key"}},"operationId":"post-advertisements"},"get":{"tags":["Debug"],"description":"広告情報取得, ordered by 'updated'","parameters":[{"in":"query","name":"limit","required":false,"description":"max items to be returned. default: 100","schema":{"type":"integer","format":"int32"}},{"in":"query","name":"offset","required":false,"description":"offset. Usually, it worked with 'limit'. default : 0","schema":{"type":"integer","format":"int32"}}],"responses":{"200":{"description":"results of get Advertisements","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AdItem"}}}},"401":{"description":"Wrong API key"}},"operationId":"get-advertisements"}},"/advertisements/{adId}/show":{"post":{"tags":["Advertisement"],"summary":"7. 広告情報視聴の開始通知","description":"HUにおける広告の表示をサーバに通知する\n","parameters":[{"in":"path","name":"adId","required":true,"schema":{"type":"string"}},{"in":"query","name":"lat","required":true,"schema":{"type":"number"}},{"in":"query","name":"lng","required":true,"schema":{"type":"number"}}],"responses":{"200":{"description":"ok"},"401":{"description":"Wrong API key"},"404":{"description":"No Advertisement with the adId"}},"operationId":"post-advertisements-adId-show"}},"/advertisements/{adId}/hide":{"post":{"tags":["Advertisement"],"summary":"7. 広告情報視聴の終了通知","description":"HUにおける広告の非表示（次の広告への遷移を含む）をサーバに通知する。\nまた、CAPP上にてクーポンの詳細が表示されたことや、バナー広告の詳細（詳細画像もしくは外部URL）が閲覧されたことをサーバに通知する。\n","parameters":[{"in":"path","name":"adId","required":true,"schema":{"type":"string"}},{"in":"query","name":"reason","description":"Notify the server that the ad has stopped to be displayed and its reason\n  * `complete` - The requested display time has been satisfied.\n  * `close` - The display was interrupted by a user operation.\n  * `leave` - The other reason (vehicle began to moves, screen transition by other user operation, ...)\n  * `capp` - CAPP shows detail screen of a coupon or detailed information of a banner ad. This is used only by CAPP.\n","schema":{"type":"string","enum":["complete","close","leave","capp"]},"required":true},{"in":"query","name":"lat","required":true,"schema":{"type":"number"}},{"in":"query","name":"lng","required":true,"schema":{"type":"number"}}],"responses":{"200":{"description":"ok"},"401":{"description":"Wrong API key"},"404":{"description":"No Advertisement with the adId"}},"operationId":"post-advertisements-adId-hide"}},"/advertisements/{adId}/sendmail":{"post":{"tags":["Advertisement"],"summary":"Share ad or coupon via e-mail","description":"Send an e-mail to the driver's address including the specified ad or coupon\n","parameters":[{"in":"path","name":"adId","description":"ID of the ad or coupon to include in the e-mail","required":true,"schema":{"type":"string"}},{"in":"query","name":"lat","required":true,"schema":{"type":"number"}},{"in":"query","name":"lng","required":true,"schema":{"type":"number"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SendMailRequest"}}},"description":"additional information which may be required to send an e-mail to the driver"},"responses":{"204":{"description":"ok"},"400":{"description":"Required parameter(s) missing"},"401":{"description":"Wrong API key"},"404":{"description":"No Advertisement with the adId"},"500":{"description":"Failed to send a mail (including when driver's e-mail address is unknown)"}},"operationId":"post-advertisements-adId-sendmail"}},"/advertisements/{adId}/usecoupon":{"parameters":[{"schema":{"type":"string"},"name":"adId","in":"path","required":true}],"post":{"tags":["Advertisement"],"summary":"","operationId":"post-advertisements-adId-usecoupon","responses":{"204":{"description":"ok"},"400":{"description":"Required parameter(s) missing"},"401":{"description":"Wrong API key"},"404":{"description":"No Advertisement with the adId"}},"parameters":[{"schema":{"type":"number"},"in":"query","name":"lat","required":true},{"schema":{"type":"number"},"in":"query","name":"lng","required":true}],"description":"クーポンの利用通知"}},"/advertisements/{adId}":{"get":{"tags":["Debug"],"summary":"広告情報取得","parameters":[{"in":"path","name":"adId","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"results of get Advertisements","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AdItem"}}}},"401":{"description":"Wrong API key"},"404":{"description":"No Advertisement with the adId"}},"description":"指定IDの広告取得","operationId":"post-advertisements-adId"}},"/vehicleevent":{"post":{"tags":["Vehicle"],"summary":"9. 車両イベントの通知","description":"車両の動作（発車、停車）をサーバに通知する\n車両停車場所の近辺にクーポンを配布しているPOIがある場合にはCAPPにそのPOI情報を通知する\n","parameters":[{"in":"query","name":"lat","required":true,"schema":{"type":"number"}},{"in":"query","name":"lng","required":true,"schema":{"type":"number"}},{"in":"query","name":"event","required":true,"schema":{"type":"string","enum":["leave","arrive"]},"description":"vehicle event type\n - `leave` - began to move\n - `arrive` - arrived at the destination or just stopped\n"}],"responses":{"200":{"description":"ok"},"400":{"description":"Invalid query parameters"},"401":{"description":"Wrong API key"}},"operationId":"post-vehicleevent"}},"/version":{"get":{"tags":["Debug"],"description":"version情報取得","responses":{"200":{"description":"ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Version"}}}}},"operationId":"get-version"}},"/coupons/{couponId}":{"parameters":[{"schema":{"type":"string"},"name":"couponId","in":"path","required":true}],"get":{"summary":"Your GET endpoint","tags":[],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["found","not_found","expired"]},"coupon":{"$ref":"#/components/schemas/IssuedCoupon"}},"required":["status"]},"examples":{}}}}},"operationId":"get-coupons-couponId","description":"get a coupon"}},"/registrations":{"put":{"tags":["Registration"],"summary":"Notify the server of the driver ID and Firebase registration token that a CAPP is using.","description":"A CAPP should call this API in following cases:\n* When a new driver ID is generated in the app (e.g. the app is launched for the first time)\n* When Firebase registration token is created (e.g. the app is launched for the first time) or updated (e.g. a\n  user has cleared app data)\n* More than one month has passed since the app previously called the API, i.e. please call this API once in\n  about 30 days.\n","operationId":"put-registrations","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"fbRegistrationToken":{"type":"string"}}}}}},"responses":{"204":{"description":"Registration is successfully completed or updated."},"400":{"description":"bad input parameter"}}}},"/favorites":{"get":{"tags":["Favorite"],"summary":"Retrieve a list of ads and coupons which have been added to the driver's favorite list","responses":{"200":{"description":"list of ads and coupons","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/FavoriteItem"}}}}},"500":{"description":"Failed to retrieve ads and/or coupons from driver's favorite list"}},"operationId":"get-favorites","description":"Get favorite coupons"},"post":{"tags":["Favorite"],"summary":"Add specified ad or coupon to the driver's favorite list","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddFavoriteRequest"},"examples":{}}}},"responses":{"200":{"description":"ok"},"400":{"description":"Required parameter(s) missing"},"415":{"description":"Request body is not in JSON format"},"500":{"description":"Failed to add the ad or coupon to driver's favorite list"}},"operationId":"post-favorites","description":"Post an favorite coupon"}},"/favorites/{adId}":{"delete":{"tags":["Favorite"],"summary":"Remove specified ad or coupon from the driver's favorite list","parameters":[{"in":"path","name":"adId","description":"ID of the ad or coupon","required":true,"schema":{"type":"string"}}],"responses":{"204":{"description":"ok"},"400":{"description":"Required parameter(s) missing"},"500":{"description":"Failed to remove the ad or coupon from driver's favorite list"}},"operationId":"delete-favorites-adid","description":"Delete an favorite coupon"}},"/links":{"get":{"tags":["Links"],"summary":"Retrieve a list of linked driver IDs. If there is no link, an empty array is returned.","responses":{"200":{"description":"list of linked driver IDs","content":{"application/json":{"schema":{"type":"array","items":{"type":"string"}}}}},"500":{"description":"Failed to retrieve linked IDs"}},"operationId":"get-links","description":"Get link"},"post":{"tags":["Links"],"summary":"Create a link with specified driver ID","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateLinkRequest"}}}},"responses":{"204":{"description":"ok"},"400":{"description":"Required parameter missing or invalid"},"500":{"description":"Failed to create a link"}},"operationId":"post-links","description":"Create new link"},"delete":{"tags":["Links"],"summary":"Delete all links of given Driver ID","responses":{"204":{"description":"ok"},"500":{"description":"Failed to delete links"}},"operationId":"delete-links","description":"Delete links"}},"/destinations":{"get":{"tags":["Destination"],"summary":"Retrieve destination POI(s) set by CAPP.","description":"Retrieve a list of POIs that have been set up by a \"PUT /destinations\" operation.","operationId":"get-destinations","responses":{"200":{"description":"A destination object including POI(s) is returned.","content":{"application/json":{"schema":{"type":"object","required":["id","pois"],"properties":{"id":{"type":"string","description":"A string that uniquely identifies this destination object.\nWhen the destination object is updated, a different string is assigned to this ID.\n"},"pois":{"type":"array","items":{"$ref":"#/components/schemas/DestinationItem"}}}}}}},"404":{"description":"No destination POI is currently set up."}}},"put":{"tags":["Destination"],"summary":"Set up destination POI(s) for a head unit.","description":"The server keeps specified destination POIs for all linked driver IDs.\nWhen another PUT operation is made, previous destination POIs are replaced with the new ones.\n","operationId":"put-destinations","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DestinationItem"}}}}},"responses":{"204":{"description":"Destination POIs are successfully set up."},"400":{"description":"bad input parameter"}}},"delete":{"tags":["Destination"],"summary":"Delete destination POI(s).","description":"Delete destination POI(s) from all linked driver IDs.","operationId":"delete-destinations","parameters":[{"in":"query","name":"id","description":"Optional. Specify the ID included in a destination object retrieved through \"GET /destinations\" operation.\nThis makes sure that when the destination object is updated through \"PUT /destinations\" before\n\"DELETE /operations\" is issued, the new object is NOT deleted.\n","schema":{"type":"string"}}],"responses":{"204":{"description":"Destination POIs are successfully deleted."},"404":{"description":"Specified destination POIs are already deleted or no longer exist."}}}},"/navigation":{"get":{"tags":["Navigation"],"summary":"Retrieve destination(s) and route information of current navigation of linked HU.","description":"Retrieve a list of destinations and route information of a navigation that the linked HU is currently running.\n","operationId":"get-navigation","responses":{"200":{"description":"Destinations and route information (if available) are returned.","content":{"application/json":{"schema":{"type":"object","required":["destinations"],"properties":{"destinations":{"description":"A list of locations to visit, in the order. i.e. The array should include \"Waypoint 1\",\n\"Waypoint 2\", ... \"Waypoint N\", and \"Final destination\".\n","type":"array","items":{"$ref":"#/components/schemas/DestinationItem"}},"route":{"$ref":"#/components/schemas/LineStringFeature"}}}}}},"404":{"description":"No navigation information is available because the HU is not running a navigation."}}},"put":{"tags":["Navigation"],"summary":"Set or update destination(s) and route information of current navigation.","description":"When a HU starts navigation, or its route is updated, the HU should call this API to set/update destination(s).\nIf route information is available, the HU should include it in the request.\nThe server will notify all linked CAPPs that the navigation information has been updated.\n","operationId":"put-navigation","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","required":["destinations"],"properties":{"destinations":{"description":"A list of locations to visit, in the order. i.e. The array should include \"Waypoint 1\", \"Waypoint 2\",\n... \"Waypoint N\", and \"Final destination\".\n","type":"array","items":{"$ref":"#/components/schemas/DestinationItem"}},"route":{"$ref":"#/components/schemas/LineStringFeature"}}}}}},"responses":{"204":{"description":"Navigation information is successfully set or updated."},"400":{"description":"bad input parameter"}}},"delete":{"tags":["Navigation"],"summary":"Delete navigation information.","description":"Delete destinations and route information of a navigation.\nHU should call this API when a navigation is completed or cancelled.\nThe server will notify all linked CAPPs that the navigation information has been deleted.\n","operationId":"delete-navigation","responses":{"204":{"description":"Navigation information is successfully deleted."},"404":{"description":"Navigation information has not been set."}}}}},"components":{"securitySchemes":{"api_key":{"type":"apiKey","name":"x-driver-id","in":"header"}},"schemas":{"BrandItem":{"type":"object","required":["brandId","iconUrl"],"properties":{"brandId":{"type":"string","example":"xxx"},"iconUrl":{"type":"string","example":"https://firebasestorage.googleapis.com/v0/b/a2vp-dev.appspot.com/o/icons%2FIYwRFJOaG7YUk0XASfQh?alt=media&token=f3e8a80b-a25e-4e58-bf8d-64035571545a"},"name":{"type":"string","example":"Advertiser Name"}},"x-examples":{"example-1":{"brandId":"xxx","iconUrl":"https://firebasestorage.googleapis.com/v0/b/a2vp-dev.appspot.com/o/icons%2FIYwRFJOaG7YUk0XASfQh?alt=media&token=f3e8a80b-a25e-4e58-bf8d-64035571545a","name":"Advertiser Name"}}},"POIItem":{"type":"object","x-examples":{"example-1":{"value":{"poiId":"xxx","brandId":"yyy","name":"A POI","address":"Tokyo","tel":"string","lat":0,"lng":0,"upcoming_business_times":[180,60,120],"adIds":["string"]}}},"title":"","description":"","properties":{"poiId":{"type":"string","example":"xxx"},"brandId":{"type":"string","example":"yyy"},"name":{"type":"string","example":"A POI"},"address":{"type":"string","example":"Tokyo"},"tel":{"type":"string"},"lat":{"type":"number"},"lng":{"type":"number"},"upcoming_business_times":{"type":"array","description":"今後6時間の開店している時間長（分）、閉店している時間長（分）が交互に置かれる配列を返す。\n\ne.g.\n* [360]\n現時刻から [0, 360]分は開店している。\n\n* [180, 120, 60]\n現時刻から [0, 180]分は開店、[180, 300]分は閉店、[300, 360]分は開店している。\n\n* [0, 360]\n現時刻から [0, 0]分は開店、 [0, 360]分は閉店している。","items":{"type":"integer"}},"adIds":{"type":"array","items":{"type":"string"}}},"required":["poiId","brandId","name","lat","lng","upcoming_business_times","adIds"]},"GeoJsonObject":{"description":"GeoJSon object\nThe coordinate reference system for all GeoJSON coordinates is a geographic coordinate reference system, using the World Geodetic System 1984 (WGS 84) datum, with longitude and latitude units of decimal degrees. This is equivalent to the coordinate reference system identified by the Open Geospatial Consortium (OGC) URN An OPTIONAL third-position element SHALL be the height in meters above or below the WGS 84 reference ellipsoid. In the absence of elevation values, applications sensitive to height or depth SHOULD interpret positions as being at local ground or sea level.\n","externalDocs":{"url":"https://tools.ietf.org/html/rfc7946#section-3"},"type":"object","properties":{"type":{"type":"string","enum":["Feature","FeatureCollection","Point","MultiPoint","LineString","MultiLineString","Polygon","MultiPolygon","GeometryCollection"]}},"required":["type"],"discriminator":{"propertyName":"type"},"title":"","x-internal":false,"x-examples":{}},"Geometry":{"description":"Abstract type for all GeoJSon object except Feature and FeatureCollection\n","externalDocs":{"url":"https://tools.ietf.org/html/rfc7946#section-3"},"allOf":[{"$ref":"#/components/schemas/GeoJsonObject"},{"type":"object","properties":{"type":{"type":"string","enum":["Point","LineString"]}},"required":["type"],"discriminator":{"propertyName":"type"}}]},"GeometryElement":{"description":"Abstract type for all GeoJSon 'Geometry' object the type of which is not 'GeometryCollection'\n","externalDocs":{"url":"https://tools.ietf.org/html/rfc7946#section-3"},"allOf":[{"$ref":"#/components/schemas/Geometry"},{"type":"object","properties":{"type":{"type":"string","enum":["Point","LineString"]}},"required":["type"],"discriminator":{"propertyName":"type"}}]},"Feature":{"description":"GeoJSon 'Feature' object","externalDocs":{"url":"https://tools.ietf.org/html/rfc7946#section-3.2"},"allOf":[{"$ref":"#/components/schemas/GeoJsonObject"},{"type":"object","required":["geometry","properties"],"properties":{"geometry":{"allOf":[{"nullable":true},{"$ref":"#/components/schemas/Geometry"}]},"properties":{"type":"object","nullable":true}}}]},"Position":{"description":"GeoJSon fundamental geometry construct.\nA position is an array of numbers. There MUST be two or more elements. The first two elements are longitude and latitude, or easting and northing, precisely in that order and using decimal numbers. Altitude or elevation MAY be included as an optional third element.\nImplementations SHOULD NOT extend positions beyond three elements because the semantics of extra elements are unspecified and ambiguous. Historically, some implementations have used a fourth element to carry a linear referencing measure (sometimes denoted as \"M\") or a numerical timestamp, but in most situations a parser will not be able to properly interpret these values. The interpretation and meaning of additional elements is beyond the scope of this specification, and additional elements MAY be ignored by parsers.\n","externalDocs":{"url":"https://tools.ietf.org/html/rfc7946#section-3.1.1"},"type":"array","minItems":2,"maxItems":3,"items":{"type":"number"},"example":[139.7671248,35.68123620000001]},"LineStringCoordinates":{"description":"GeoJSon fundamental geometry construct, array of two or more positions.\n","externalDocs":{"url":"https://tools.ietf.org/html/rfc7946#section-3.1.4"},"type":"array","items":{"$ref":"#/components/schemas/Position"},"minItems":2,"example":[[139.7671248,35.68123620000001],[139.76347699573972,35.67794368357555],[139.7697962801788,35.67617449450746]]},"Point":{"description":"GeoJSon geometry","externalDocs":{"url":"https://tools.ietf.org/html/rfc7946#section-3.1.2"},"allOf":[{"$ref":"#/components/schemas/GeometryElement"},{"type":"object","required":["type","coordinates"],"properties":{"type":{"type":"string","enum":["Point"]},"coordinates":{"$ref":"#/components/schemas/Position"}}}]},"LineString":{"description":"GeoJSon geometry","externalDocs":{"url":"https://tools.ietf.org/html/rfc7946#section-3.1.4"},"allOf":[{"$ref":"#/components/schemas/GeometryElement"},{"type":"object","required":["coordinates"],"properties":{"coordinates":{"$ref":"#/components/schemas/LineStringCoordinates"}}}]},"PointFeature":{"description":"GeoJSon 'Feature' object that has a Point","externalDocs":{"url":"https://tools.ietf.org/html/rfc7946#section-3.2"},"allOf":[{"$ref":"#/components/schemas/GeoJsonObject"},{"type":"object","required":["geometry","properties"],"properties":{"geometry":{"allOf":[{"nullable":true},{"$ref":"#/components/schemas/Point"}]},"properties":{"type":"object","nullable":true}}}]},"LineStringFeature":{"description":"GeoJSon 'Feature' object that has a LineString","externalDocs":{"url":"https://tools.ietf.org/html/rfc7946#section-3.2"},"allOf":[{"$ref":"#/components/schemas/GeoJsonObject"},{"type":"object","required":["geometry","properties"],"properties":{"geometry":{"allOf":[{"nullable":true},{"$ref":"#/components/schemas/LineString"}]},"properties":{"type":"object","nullable":true}}}]},"HereAdRequest":{"type":"object","required":["type","geo"],"properties":{"type":{"type":"string","enum":["here"]},"geo":{"$ref":"#/components/schemas/PointFeature"},"heading":{"description":"Direction of a vehicle, in degrees East from true North. Its range is (0.0, 360.0].","type":"number","example":32.3512184}}},"RouteAdRequest":{"type":"object","required":["type","geo"],"properties":{"type":{"type":"string","enum":["route"]},"geo":{"$ref":"#/components/schemas/LineStringFeature"}}},"HistoryAdRequest":{"type":"object","required":["type","time"],"properties":{"type":{"type":"string","enum":["history"]},"time":{"type":"number","description":"milliseconds"}}},"AdRequest":{"oneOf":[{"$ref":"#/components/schemas/HereAdRequest"},{"$ref":"#/components/schemas/RouteAdRequest"},{"$ref":"#/components/schemas/HistoryAdRequest"}],"discriminator":{"propertyName":"type","mapping":{"here":"#/components/schemas/HereAdRequest","route":"#/components/schemas/RouteAdRequest","history":"#/components/schemas/HistoryAdRequest"}}},"AddFavoriteRequest":{"type":"object","required":["adId"],"properties":{"adId":{"type":"string"}}},"CreateLinkRequest":{"type":"object","required":["driverId"],"properties":{"driverId":{"type":"string"}}},"AdItem":{"type":"object","x-examples":{"example-1":{"adId":"abdef","brandId":"xyz","contents":[{"type":"image","url":"https://firebasestorage.googleapis.com/v0/b/a2vp-dev.appspot.com/o/images%2FTDP7nVFrFk4Qqfo2VQGb?alt=media&token=827f7443-f3cf-4687-99bf-a3c48065b629","coupon":{"title":"オレンジジュース","note":"今なら１００円引き","distribution":{"image_url":"https://example.com/coupon_image"},"effective_hour":4}}],"updated":"2019-08-24T14:15:22Z","duration":15000,"detailedInformation":{"type":"image","src":"string"}}},"description":"","properties":{"adId":{"type":"string","example":"abdef"},"brandId":{"type":"string","example":"xyz"},"contents":{"type":"array","items":{"$ref":"#/components/schemas/Content"}},"updated":{"type":"string","format":"date-time"},"duration":{"type":"integer","format":"int32","description":"Specify how long an image content should be shown, in milliseconds.\nFor sound and video contents, this value is ignored and the contents should be played until end.\n","example":15000},"detailedInformation":{"oneOf":[{"properties":{"type":{"type":"string","enum":["image"]},"src":{"type":"string"}},"required":["type","src"]},{"properties":{"type":{"type":"string","enum":["external_link"]},"url":{"type":"string"}},"required":["type","url"]}],"type":"object"}},"required":["adId","brandId","contents","updated","duration"]},"ImageContent":{"type":"object","required":["type","url"],"properties":{"type":{"type":"string","enum":["image"]},"url":{"type":"string","format":"url","example":"https://firebasestorage.googleapis.com/v0/b/a2vp-dev.appspot.com/o/images%2FTDP7nVFrFk4Qqfo2VQGb?alt=media&token=827f7443-f3cf-4687-99bf-a3c48065b629"},"coupon":{"$ref":"#/components/schemas/Coupon"}},"x-examples":{"example-1":{"type":"image","url":"https://firebasestorage.googleapis.com/v0/b/a2vp-dev.appspot.com/o/images%2FTDP7nVFrFk4Qqfo2VQGb?alt=media&token=827f7443-f3cf-4687-99bf-a3c48065b629","coupon":{"title":"オレンジジュース","note":"今なら１００円引き","distribution":{"image_url":"https://example.com/coupon_image"},"effective_hour":4}},"example-2":{"type":"image","url":"https://firebasestorage.googleapis.com/v0/b/a2vp-dev.appspot.com/o/images%2FTDP7nVFrFk4Qqfo2VQGb?alt=media&token=827f7443-f3cf-4687-99bf-a3c48065b629","coupon":{"title":"オレンジジュース","note":"今なら１００円引き","distribution":{"image_url":"https://example.com/coupon_image"},"date_range":{"start":"2021-05-01","end":"2021-05-10"}}}}},"SoundContent":{"type":"object","required":["type"],"properties":{"type":{"type":"string","enum":["sound"]}}},"VideoContent":{"type":"object","required":["type","url"],"properties":{"type":{"type":"string","enum":["video"]},"url":{"type":"string","format":"url","example":"https://firebasestorage.googleapis.com/v0/b/a2vp-dev.appspot.com/o/advertisers%2F1lFj2UBtVsoQaOWnBWzW%2Fbrands%2F6bUZ80XBbqn8j454MG02%2Fads%2FkxX9YkD8ivGtuZTHg0AQ%2Fimage?alt=media&token=ff046bd3-bd90-4a02-afe9-904d7deeda6a"}}},"Content":{"oneOf":[{"$ref":"#/components/schemas/ImageContent"},{"$ref":"#/components/schemas/SoundContent"},{"$ref":"#/components/schemas/VideoContent"}],"discriminator":{"propertyName":"type","mapping":{"image":"#/components/schemas/ImageContent","sound":"#/components/schemas/SoundContent","video":"#/components/schemas/VideoContent"}},"x-examples":{},"description":""},"Coupon":{"x-examples":{"example-1":{"title":"オレンジジュース","note":"今なら１００円引き","distribution":{"image_url":"https://example.com/coupon_image"},"effective_hour":4},"example-2":{"title":"オレンジジュース","note":"今なら１００円引き","distribution":{"image_url":"https://example.com/coupon_image"},"date_range":{"start":"2021-05-01","end":"2021-05-10"}}},"type":"object","properties":{"title":{"type":"string","example":"オレンジジュース"},"note":{"type":"string","example":"今なら１００円引き"},"distribution":{"type":"object","required":["image_url"],"properties":{"image_url":{"type":"string","example":"https://example.com/coupon_image"}}},"effective_hour":{"type":"integer","description":"There is either effective_hour or date_range.","example":4},"date_range":{"$ref":"#/components/schemas/DateRange"}},"required":["title","note","distribution"]},"SendMailRequest":{"type":"object","properties":{"emailAddress":{"type":"string","description":"A destination e-mail address"}}},"Version":{"type":"object","properties":{"version":{"type":"string","description":"version description"},"hash":{"type":"string","description":"git commit hash."}}},"DateRange":{"title":"DateRange","type":"object","properties":{"start":{"type":"string","format":"date","example":"2021-05-01"},"end":{"type":"string","format":"date","example":"2021-05-10"}},"required":["start","end"],"x-examples":{"example-1":{"start":"2021-05-01","end":"2021-05-10"}},"description":""},"IssuedCoupon":{"title":"IssuedCoupon","x-examples":{"example-1":{"value":{"url":"http://example.com","number":123,"validity_from":1624439103894,"validity_to":1624439203894}}},"type":"object","properties":{"url":{"type":"string","format":"uri"},"validity_from":{"type":"integer","format":"date-time","description":"epoch millisec"},"validity_to":{"format":"date-time","type":"integer","description":"epoch millisec"}},"required":["url","validity_to"]},"TimeRange":{"title":"TimeRange","type":"object","x-examples":{"example-1":{"value":{"start":"07:00","end":"07:00"}}},"properties":{"start":{"type":"string","format":"timespec-hour","example":"07:00"},"end":{"type":"string","format":"timespec-hour","example":"07:00"}},"required":["start","end"],"description":""},"FavoriteItem":{"type":"object","required":["ad","added"],"properties":{"adId":{"$ref":"#/components/schemas/AdItem"},"added":{"type":"string","format":"date"}}},"DestinationItem":{"type":"object","required":["name","lat","lng"],"properties":{"name":{"type":"string","description":"A string representing the destination.\nThis is shown on a head unit and is presented to a driver. It can be a name of\na POI (e.g. \"東京タワー\") or a generic address (e.g. \"渋谷区渋谷1丁目\").\nAn empty string is not allowed.\n"},"lat":{"type":"number"},"lng":{"type":"number"}}}}}}